<template>
  <div v-if="cart">
    <div class="container">
      <h1 class="display-4 font-weight-bolder">Cart</h1>
    </div>
    <table class="table">
      <thead>
        <tr>
          <th>Image</th>
          <th>Name</th>
          <th>Weight</th>
          <th>Type</th>
          <th>Kind</th>
          <th>Price</th>
          <th>Quantity</th>
          <th>Total</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="chocolate in cart.chocolatesInCart" :key="chocolate.chocolateId">
          <td><img :src="getChocolateImagePath(chocolate.image)" alt="Chocolate Image" width="100" height="80"></td>
          <td>{{ chocolate.name }}</td>
          <td>{{ chocolate.weight }}g</td>
          <td>{{ chocolate.chocolateType }}</td>
          <td>{{ chocolate.chocolateKind }}</td>
          <td>{{ chocolate.price }} RSD</td>
          <td>
            <input type="number" v-model="chocolate.quantity" @change="updateCart(chocolate)" :min="1" :max="chocolate.maxQuantity" />
          </td>
          <td>{{ chocolate.price * chocolate.quantity }} RSD</td>
          <td>
            <button class="custom-btn btn-6-red" @click="removeItemFromCart(chocolate.chocolateId)">Remove</button>
          </td>
        </tr>
      </tbody>
    </table>
    <h3>Total Price: {{ totalPrice }} RSD</h3>
    <button class="custom-btn btn-6" @click="finalizePurchase">Purchase</button>
  </div>
  <div v-else>
    <p>Your cart is empty.</p>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  data() {
    return {
      cart: null,
      totalPrice: 0,
      factories: []  // Lokalne fabrike
    };
  },
  mounted() {
  this.fetchFactories().then(() => {
    this.fetchCart(); // Ova funkcija će se pozvati tek kada se podaci o fabrici učitaju
  });
},
methods: {
  async fetchFactories() {
    try {
      const response = await axios.get('http://localhost:3000/factories');
      this.factories = response.data;
      console.log('Fabrike učitane:', this.factories);
    } catch (error) {
      console.error('Greška pri učitavanju fabrika', error);
    }
  },
  async fetchCart() {
    const fulluser = JSON.parse(localStorage.getItem('fulluser'));
    
    if (fulluser && fulluser.username) {
      const username = fulluser.username;
      console.log(`Pronađen korisnik u localStorage: ${username}`);

      try {
        const response = await axios.get(`http://localhost:3000/carts/${username}`);
        console.log('Uspešno dobijeni podaci o korpi:', response.data);
        this.cart = response.data;

        if (!this.factories || this.factories.length === 0) {
          console.error("Podaci o fabrici još nisu učitani. Pokušajte ponovo kasnije.");
          return;
        }

        // Ažurirajte detalje o čokoladi iz strukture fabrike
        this.cart.chocolatesInCart.forEach(chocolate => {
          const originalChocolate = this.getOriginalChocolateById(chocolate.chocolateId);
          if (originalChocolate) {
            chocolate.name = originalChocolate.name;
            chocolate.price = originalChocolate.price;
            chocolate.image = originalChocolate.image;
            chocolate.weight = originalChocolate.weight;
            chocolate.chocolateType = originalChocolate.chocolateType;
            chocolate.chocolateKind = originalChocolate.chocolateKind;
          } else {
            console.error(`Čokolada sa ID-jem ${chocolate.chocolateId} nije pronađena u fabrici.`);
          }
        });

        this.calculateTotalPrice();
        console.log('Prikaz trenutnog stanja korpe:', this.cart);
      } catch (error) {
        console.error('Greška pri dohvatanju korpe', error);
      }
    } else {
      console.error('Korisničko ime nije pronađeno u localStorage.');
    }
  },
    calculateTotalPrice() {
      this.totalPrice = this.cart.chocolatesInCart.reduce((total, chocolate) => {
        return total + (chocolate.price * chocolate.quantity);
      }, 0);
    },
    updateCart(chocolate) {
  const quantity = chocolate.quantity;

  // Provera da li je uneta količina manja ili jednaka dostupnoj količini
  if (quantity > chocolate.maxQuantity) {
    alert(`Ne možete dodati više od ${chocolate.maxQuantity} jedinica čokolade ${chocolate.name}.`);
    return;
  }

  // Ako je sve u redu, pošalji zahtev na backend
  axios.post('http://localhost:3000/carts/update-cart', {
    username: JSON.parse(localStorage.getItem('fulluser')).username,
    chocolateId: chocolate.chocolateId,
    newQuantity: chocolate.quantity
  })
  .then(() => {
    this.calculateTotalPrice();
  })
  .catch(error => {
    if (error.response && error.response.data.message) {
      alert(error.response.data.message);  // Prikazivanje poruke greške sa servera
    } else {
      console.error('Greška pri ažuriranju korpe', error);
    }
  });
},

    removeItemFromCart(chocolateId) {
    console.log("Pritisnuto dugme za uklanjanje stavke sa ID:", chocolateId);
    axios.post('http://localhost:3000/carts/remove-from-cart', {
      username: JSON.parse(localStorage.getItem('fulluser')).username,
      chocolateId: chocolateId
    })
    .then(() => {
      this.cart.chocolatesInCart = this.cart.chocolatesInCart.filter(item => item.chocolateId !== chocolateId);
      this.calculateTotalPrice();
      console.log("Stavka uspešno uklonjena iz korpe.");
    })
    .catch(error => {
      console.error('Greška pri uklanjanju stavke iz korpe', error);
    });
  },
    getOriginalChocolateById(chocolateId) {
  // Proverite da li su fabrike definisane i da li su niz
  if (!Array.isArray(this.factories)) {
    console.error("Fabrike nisu definisane ili nisu niz.");
    return null; // Vraćamo null ako fabrike nisu definisane ili nisu niz
  }

  console.log("Pretražujem čokoladu sa ID-jem:", chocolateId);
  console.log("Trenutne fabrike:", this.factories);

  // Pristupanje čokoladama unutar `name` objekta fabrike
  for (let factory of this.factories) {
    const chocolatesArray = factory.name.chocolates;
    if (Array.isArray(chocolatesArray)) {
      const foundChocolate = chocolatesArray.find(c => c.id === chocolateId);
      if (foundChocolate) {
        console.log("Čokolada pronađena:", foundChocolate);
        return foundChocolate;
      }
    }
  }

  console.error(`Čokolada sa ID-jem ${chocolateId} nije pronađena u fabrici.`);
  return null; // Ako čokolada nije pronađena
},

    getChocolateImagePath(image) {
      if (!image) {
        return '/src/assets/default-chocolate.png';
      }

      const images = import.meta.glob('../assets/*.{jpg,png,jpeg}');
      const imageName = image.split('/').pop();
      for (const path in images) {
        if (path.includes(imageName)) {
          return path.replace('../assets', '/src/assets');
        }
      }
      return '/src/assets/default-chocolate.png';
    },
    finalizePurchase() {
      // Funkcija za slanje POST zahteva ka API-ju da završi kupovinu
      const purchaseData = {
        username: JSON.parse(localStorage.getItem('fulluser')).username,
        factory: this.cart.chocolatesInCart[0].factoryId  // Pretpostavljamo da svi artikli dolaze iz iste fabrike
      };

      axios.post("http://localhost:3000/purchases/purchase", purchaseData)
        .then((response) => {
          alert("Kupovina uspešno obavljena!");
          this.$router.push("/my-purchases"); // Preusmeri korisnika na stranicu sa njegovim kupovinama
        })
        .catch((error) => {
          console.error("Greška pri obradi kupovine:", error);
          alert("Došlo je do greške prilikom obrade kupovine.");
        });
  }
}
};
</script>

<style scoped>

.display-4 {
  font-family: 'Lato', sans-serif;
  font-size: 3rem;
  font-weight: 700;
  text-align: center;
  color: #333;
  margin-bottom: 1.5rem;
  text-transform: uppercase;
  letter-spacing: 2px;
  position: relative;
}

.display-4::after {
  content: ''; 
  width: 1350px;
  height: 4px;
  background-color: #ff7f00;
  display: block;
  margin: 10px auto 0;
}

button {
  margin: 10px;
}
.custom-btn {
  width: 180px;
  height: 40px;
  color: #fff;
  border-radius: 5px;
  padding: 10px 25px;
  font-family: 'Lato', sans-serif;
  font-weight: 500;
  background: transparent;
  cursor: pointer;
  transition: all 1.0s ease;
  position: relative;
  display: inline-block;
  box-shadow: inset 2px 2px 2px 0px rgba(255,255,255,.5),
              7px 7px 20px 0px rgba(0,0,0,.1),
              4px 4px 5px 0px rgba(0,0,0,.1);
  outline: none;
}

/* 7 */
.btn-7 {
  background: linear-gradient(0deg, rgba(255,151,0,1) 0%, rgba(251,75,2,1) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
}
.btn-7 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-7:before,
.btn-7:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7:before {
  height: 0%;
  width: 2px;
}
.btn-7:after {
  width: 0%;
  height: 2px;
}
.btn-7:hover {
  color: rgba(251,75,2,1);
  background: transparent;
}
.btn-7:hover:before {
  height: 100%;
}
.btn-7:hover:after {
  width: 100%;
}
.btn-7 span:before,
.btn-7 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7 span:before {
  width: 2px;
  height: 0%;
}
.btn-7 span:after {
  height: 2px;
  width: 0%;
}
.btn-7 span:hover:before {
  height: 100%;
}
.btn-7 span:hover:after {
  width: 100%;
}

/* 6 - Zeleno dugme */
.btn-6 {
  background: linear-gradient(0deg, rgb(42, 156, 43) 0%, rgb(81, 246, 4) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6:before,
.btn-6:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(35, 251, 2);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6:before {
  height: 0%;
  width: 2px;
}
.btn-6:after {
  width: 0%;
  height: 2px;
}
.btn-6:hover {
  color: rgb(87, 198, 109);
  background: transparent;
}
.btn-6:hover:before {
  height: 100%;
}
.btn-6:hover:after {
  width: 100%;
}
.btn-6 span:before,
.btn-6 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(2, 251, 139);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6 span:before {
  width: 2px;
  height: 0%;
}
.btn-6 span:after {
  height: 2px;
  width: 0%;
}
.btn-6 span:hover:before {
  height: 100%;
}
.btn-6 span:hover:after {
  width: 100%;
}

/* 6 - Crveno dugme */
.btn-6-red {
  background: linear-gradient(0deg, rgb(220, 53, 69) 0%, rgb(255, 107, 114) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6-red span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6-red:before,
.btn-6-red:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red:before {
  height: 0%;
  width: 2px;
}
.btn-6-red:after {
  width: 0%;
  height: 2px;
}
.btn-6-red:hover {
  color: rgb(255, 150, 150);
  background: transparent;
}
.btn-6-red:hover:before {
  height: 100%;
}
.btn-6-red:hover:after {
  width: 100%;
}
.btn-6-red span:before,
.btn-6-red span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red span:before {
  width: 2px;
  height: 0%;
}
.btn-6-red span:after {
  height: 2px;
  width: 0%;
}
.btn-6-red span:hover:before {
  height: 100%;
}
.btn-6-red span:hover:after {
  width: 100%;
}

.table tbody tr:hover td {
  background-color: #f1c16a !important;
  transition: background-color 1.0s ease;
  cursor: pointer;
}

.table tbody tr td {
  transition: background-color 0.3s ease;
}

.table td img {
  width: 100px;
  height: 80px;
}

h3 {
  font-size: 2.0rem;
  font-weight: bold;
}
</style>
